<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfpurchaseWebshopRequest ArrayType
 * Meta information extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfpurchaseWebshopRequest
 * @subpackage Arrays
 */
class ArrayOfpurchaseWebshopRequest extends AbstractStructArrayBase
{
    /**
     * The purchaseWebshopRequest
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\PurchaseWebshopRequest[]
     */
    public $purchaseWebshopRequest;
    /**
     * Constructor method for ArrayOfpurchaseWebshopRequest
     * @uses ArrayOfpurchaseWebshopRequest::setPurchaseWebshopRequest()
     * @param \StructType\PurchaseWebshopRequest[] $purchaseWebshopRequest
     */
    public function __construct(array $purchaseWebshopRequest = array())
    {
        $this
            ->setPurchaseWebshopRequest($purchaseWebshopRequest);
    }
    /**
     * Get purchaseWebshopRequest value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\PurchaseWebshopRequest[]|null
     */
    public function getPurchaseWebshopRequest()
    {
        return isset($this->purchaseWebshopRequest) ? $this->purchaseWebshopRequest : null;
    }
    /**
     * This method is responsible for validating the values passed to the setPurchaseWebshopRequest method
     * This method is willingly generated in order to preserve the one-line inline validation within the setPurchaseWebshopRequest method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validatePurchaseWebshopRequestForArrayConstraintsFromSetPurchaseWebshopRequest(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfpurchaseWebshopRequestPurchaseWebshopRequestItem) {
            // validation for constraint: itemType
            if (!$arrayOfpurchaseWebshopRequestPurchaseWebshopRequestItem instanceof \StructType\PurchaseWebshopRequest) {
                $invalidValues[] = is_object($arrayOfpurchaseWebshopRequestPurchaseWebshopRequestItem) ? get_class($arrayOfpurchaseWebshopRequestPurchaseWebshopRequestItem) : sprintf('%s(%s)', gettype($arrayOfpurchaseWebshopRequestPurchaseWebshopRequestItem), var_export($arrayOfpurchaseWebshopRequestPurchaseWebshopRequestItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The purchaseWebshopRequest property can only contain items of type \StructType\PurchaseWebshopRequest, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set purchaseWebshopRequest value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\PurchaseWebshopRequest[] $purchaseWebshopRequest
     * @return \ArrayType\ArrayOfpurchaseWebshopRequest
     */
    public function setPurchaseWebshopRequest(array $purchaseWebshopRequest = array())
    {
        // validation for constraint: array
        if ('' !== ($purchaseWebshopRequestArrayErrorMessage = self::validatePurchaseWebshopRequestForArrayConstraintsFromSetPurchaseWebshopRequest($purchaseWebshopRequest))) {
            throw new \InvalidArgumentException($purchaseWebshopRequestArrayErrorMessage, __LINE__);
        }
        if (is_null($purchaseWebshopRequest) || (is_array($purchaseWebshopRequest) && empty($purchaseWebshopRequest))) {
            unset($this->purchaseWebshopRequest);
        } else {
            $this->purchaseWebshopRequest = $purchaseWebshopRequest;
        }
        return $this;
    }
    /**
     * Add item to purchaseWebshopRequest value
     * @throws \InvalidArgumentException
     * @param \StructType\PurchaseWebshopRequest $item
     * @return \ArrayType\ArrayOfpurchaseWebshopRequest
     */
    public function addToPurchaseWebshopRequest(\StructType\PurchaseWebshopRequest $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\PurchaseWebshopRequest) {
            throw new \InvalidArgumentException(sprintf('The purchaseWebshopRequest property can only contain items of type \StructType\PurchaseWebshopRequest, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->purchaseWebshopRequest[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\PurchaseWebshopRequest|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\PurchaseWebshopRequest|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\PurchaseWebshopRequest|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\PurchaseWebshopRequest|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\PurchaseWebshopRequest|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string purchaseWebshopRequest
     */
    public function getAttributeName()
    {
        return 'purchaseWebshopRequest';
    }
}
