<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for SztornoResponse StructType
 * @subpackage Structs
 */
class SztornoResponse extends AbstractStructBase
{
    /**
     * The SztornoResult
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $SztornoResult;
    /**
     * The tranzakcioAzonosito
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $tranzakcioAzonosito;
    /**
     * The engedelyszam
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $engedelyszam;
    /**
     * The valaszKod
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $valaszKod;
    /**
     * The valaszMegnevezes
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $valaszMegnevezes;
    /**
     * Constructor method for SztornoResponse
     * @uses SztornoResponse::setSztornoResult()
     * @uses SztornoResponse::setTranzakcioAzonosito()
     * @uses SztornoResponse::setEngedelyszam()
     * @uses SztornoResponse::setValaszKod()
     * @uses SztornoResponse::setValaszMegnevezes()
     * @param bool $sztornoResult
     * @param int $tranzakcioAzonosito
     * @param string $engedelyszam
     * @param string $valaszKod
     * @param string $valaszMegnevezes
     */
    public function __construct($sztornoResult = null, $tranzakcioAzonosito = null, $engedelyszam = null, $valaszKod = null, $valaszMegnevezes = null)
    {
        $this
            ->setSztornoResult($sztornoResult)
            ->setTranzakcioAzonosito($tranzakcioAzonosito)
            ->setEngedelyszam($engedelyszam)
            ->setValaszKod($valaszKod)
            ->setValaszMegnevezes($valaszMegnevezes);
    }
    /**
     * Get SztornoResult value
     * @return bool|null
     */
    public function getSztornoResult()
    {
        return $this->SztornoResult;
    }
    /**
     * Set SztornoResult value
     * @param bool $sztornoResult
     * @return \StructType\SztornoResponse
     */
    public function setSztornoResult($sztornoResult = null)
    {
        // validation for constraint: boolean
        if (!is_null($sztornoResult) && !is_bool($sztornoResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($sztornoResult, true), gettype($sztornoResult)), __LINE__);
        }
        $this->SztornoResult = $sztornoResult;
        return $this;
    }
    /**
     * Get tranzakcioAzonosito value
     * @return int|null
     */
    public function getTranzakcioAzonosito()
    {
        return $this->tranzakcioAzonosito;
    }
    /**
     * Set tranzakcioAzonosito value
     * @param int $tranzakcioAzonosito
     * @return \StructType\SztornoResponse
     */
    public function setTranzakcioAzonosito($tranzakcioAzonosito = null)
    {
        // validation for constraint: int
        if (!is_null($tranzakcioAzonosito) && !(is_int($tranzakcioAzonosito) || ctype_digit($tranzakcioAzonosito))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($tranzakcioAzonosito, true), gettype($tranzakcioAzonosito)), __LINE__);
        }
        $this->tranzakcioAzonosito = $tranzakcioAzonosito;
        return $this;
    }
    /**
     * Get engedelyszam value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getEngedelyszam()
    {
        return isset($this->engedelyszam) ? $this->engedelyszam : null;
    }
    /**
     * Set engedelyszam value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $engedelyszam
     * @return \StructType\SztornoResponse
     */
    public function setEngedelyszam($engedelyszam = null)
    {
        // validation for constraint: string
        if (!is_null($engedelyszam) && !is_string($engedelyszam)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($engedelyszam, true), gettype($engedelyszam)), __LINE__);
        }
        if (is_null($engedelyszam) || (is_array($engedelyszam) && empty($engedelyszam))) {
            unset($this->engedelyszam);
        } else {
            $this->engedelyszam = $engedelyszam;
        }
        return $this;
    }
    /**
     * Get valaszKod value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getValaszKod()
    {
        return isset($this->valaszKod) ? $this->valaszKod : null;
    }
    /**
     * Set valaszKod value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $valaszKod
     * @return \StructType\SztornoResponse
     */
    public function setValaszKod($valaszKod = null)
    {
        // validation for constraint: string
        if (!is_null($valaszKod) && !is_string($valaszKod)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($valaszKod, true), gettype($valaszKod)), __LINE__);
        }
        if (is_null($valaszKod) || (is_array($valaszKod) && empty($valaszKod))) {
            unset($this->valaszKod);
        } else {
            $this->valaszKod = $valaszKod;
        }
        return $this;
    }
    /**
     * Get valaszMegnevezes value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getValaszMegnevezes()
    {
        return isset($this->valaszMegnevezes) ? $this->valaszMegnevezes : null;
    }
    /**
     * Set valaszMegnevezes value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $valaszMegnevezes
     * @return \StructType\SztornoResponse
     */
    public function setValaszMegnevezes($valaszMegnevezes = null)
    {
        // validation for constraint: string
        if (!is_null($valaszMegnevezes) && !is_string($valaszMegnevezes)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($valaszMegnevezes, true), gettype($valaszMegnevezes)), __LINE__);
        }
        if (is_null($valaszMegnevezes) || (is_array($valaszMegnevezes) && empty($valaszMegnevezes))) {
            unset($this->valaszMegnevezes);
        } else {
            $this->valaszMegnevezes = $valaszMegnevezes;
        }
        return $this;
    }
}
